//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function SpawnTextEntities(void)
{
    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 0,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0asd",
        spawnflags = 1,
        x = -1,
        y = 0.1225,
        targetname = "game_text_hale_hp"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.692,
        targetname = "game_text_damage"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 1,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.27,
        y = 0.6725,
        targetname = "game_text_hale_charge"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 2,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = 0.53,
        y = 0.6725,
        targetname = "game_text_hale_slam"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 4,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 0,
        x = -1,
        y = 0.6,
        targetname = "game_text_hale_punch"
    });

    SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 5,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        message = "0",
        spawnflags = 1,
        x = 0.493,
        y = 0.792,
        targetname = "game_text_players_alive"
    });
}
AddListener("start", SpawnTextEntities, 0);

function TickHUD(void)
{
    local hale = GetHale();
    if (isFeedbackRound || IsNotHale(hale))
        return;
    local aliveMercs = GetAliveMercCount();

    local aliveMercsStr = (aliveMercs < 10 ? " " : "") + aliveMercs;
    DoEntFire("game_text_hale_hp", "AddOutput", "message " + (IsValidPlayer(hale) ? hale.GetHealth() : " "), 0, null, null);
    DoEntFire("game_text_hale_hp", "Display", "", 0, null, null);
    DoEntFire("game_text_players_alive", "AddOutput", "message "+aliveMercsStr, 0, null, null);
    DoEntFire("game_text_players_alive", "Display", "", 0, null, null);

    local player = null;
    local haleMaxHP = hale.GetMaxHealth();
    while (player = Entities.FindByClassname(player, "player"))
    {
        if (IsValidPlayer(player) && IsNotHale(player))
        {
            local damage = floor(player in damage ? damage[player] : 0);
            //local perc = format(" (%d%%)", damage/haleMaxHP*100);
            DoEntFire("game_text_damage", "AddOutput", "message Your Damage∶ "+damage, 0, player, player);
            DoEntFire("game_text_damage", "Display", "", 0, player, player);
        }
    }

    if (IsValidPlayer(hale))
    {
        local msg = "Ready";
        if (haleChargeMeter < 0)
            msg = format("%.1fs", -haleChargeMeter);
        if (haleChargeMeter > 0)
            msg = format("%d%%", haleChargeMeter*100);
        DoEntFire("game_text_hale_charge", "AddOutput", "message             Charge∶ "+msg+"\n(Hold Action Slot or Reload)", 0, hale, hale);
        DoEntFire("game_text_hale_charge", "Display", "", 0, hale, hale);

        msg = haleSlamMeter == 0 ? "Ready" : format("%.1f", -haleSlamMeter)+"s"
        DoEntFire("game_text_hale_slam", "AddOutput", "message        Slam∶ "+msg+"\n(Hold Crouch mid-air)", 0, hale, hale);
        DoEntFire("game_text_hale_slam", "Display", "", 0, hale, hale);

        msg = isRoundSetup ? "Waiting..." : (halePunchMeter == 0 ? "Ready" : format("%.1f", -halePunchMeter)+"s")
        DoEntFire("game_text_hale_punch", "AddOutput", "message Punch∶ "+msg, 0, hale, hale);
        DoEntFire("game_text_hale_punch", "Display", "", 0, hale, hale);
    }
}
AddListener("tick", TickHUD, 2);