//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function TrySpawnAsHale(hale)
{
    if (IsNotValidPlayer(hale) || IsNotHale(hale))
        return;
    //hale.SetIsMiniBoss(true);
    hale.KeyValueFromString("targetname", "hale");

    hale.ValidateScriptScope()
    hale.GetScriptScope().Charge <- function()
    {
        if (haleIsCharge)
        {
            //NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
            NetProps.SetPropInt(hale, "m_Shared.m_bJumping", 1);
            //NetProps.SetPropInt(hale, "m_Shared.m_iAirDash", 1);
            NetProps.SetPropFloat(hale, "m_Shared.m_flJumpTime", 1);

            NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
            //local force = (hale.GetFlags() & Constants.FPlayer.FL_ONGROUND ? 3000 : 1000);
            local force = 1400;
            hale.SetAbsVelocity(hale.EyeAngles().Forward()*force)

            local catapult = Entities.FindByName(null, "hale_charge_catapult");
            catapult.SetAbsOrigin(hale.GetCenter());

            local main_viewmodel = NetProps.GetPropEntity(hale, "m_hViewModel")
            main_viewmodel.SetSequence(main_viewmodel.LookupSequence("grapple_pull_idle") )
            hale.SetSequence(hale.LookupSequence("primary_floatA") )

            local building = null;
            while (building = Entities.FindByClassname(building, "obj_*"))
            {
                if ((hale.GetCenter() - building.GetOrigin()).LengthSqr() < 10000)
                building.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), Vector(0,0,0), building.GetCenter(), 100, 1);
            }
        }
        return 0;
    }
    AddThinkToEnt(hale, "Charge")

    local chargeZone = Entities.FindByName(null, "hale_charge_zone");
    chargeZone.SetAbsOrigin(hale.GetCenter());
    DoEntFire("hale_charge_zone", "SetParent", "!activator", 0, hale, hale)
    chargeZone.SetLocalOrigin(Vector(60,0,0));

    local spotlight = Entities.FindByName(null, "spotlight");
    if (spotlight != null)
    {
        local pos = hale.GetCenter();
        spotlight.SetAbsOrigin(pos);
        DoEntFire("spotlight", "SetParent", "!activator", 0.1, hale, hale)
    }

    if (hale.GetTeam() != TF_TEAM.HALE)
    {
        hale.ForceChangeTeam(TF_TEAM.HALE, true);
        hale.ForceRespawn();
    }
    //local spawn = Entities.FindByName(null, "hale_spawn");
    //hale.SetAbsOrigin(spawn.GetOrigin());
    //hale.SetAngles(spawn.GetAbsAngles().Pitch(),spawn.GetAbsAngles().Yaw(),spawn.GetAbsAngles().Roll());
    //hale.SetPlayerClass(TF_CLASS.HEAVY);
    NetProps.SetPropInt(hale, "m_PlayerClass.m_iClass", TF_CLASS.HEAVY);
    //NetProps.SetPropInt(hale, "m_Shared.m_iDesiredPlayerClass", TF_CLASS.HEAVY);

    hale.SetCustomModelWithClassAnimations(SAXTON_HALE_MODEL_PATH)

    local wearable = null;
    while (wearable = Entities.FindByClassname(wearable, "tf_wearable*"))
    {
        if (wearable.GetOwner() == hale)
            wearable.Destroy();
    }
    local weapon = null;
    while (weapon = Entities.FindByClassname(weapon, "tf_weapon*"))
    {
        if (weapon.GetOwner() == hale)
            weapon.Destroy();
    }

    NetProps.SetPropEntity(hale, "m_hActiveWeapon", hale.GiveWeapon("Hale's Own Fists"));

    local banner = AddWeapon(hale, "tf_weapon_minigun", 444, "", 1); //Buff Banner in name, Manthreads in ID
    banner.KeyValueFromString("classname", "dummy");

    //Stats
    hale.SetModelScale(1.2, 0);
    halePunchMeter = -30;

    TickSetupHealth(hale);

    hale.AddCustomAttribute("move speed bonus", 1.7, -1);
    hale.AddCustomAttribute("cancel falling damage", 1, -1);
    hale.AddCustomAttribute("voice pitch scale", 0, -1);
    hale.AddCustomAttribute("melee range multiplier", 1.5, -1);
    hale.AddCustomAttribute("damage bonus", 3, -1);
    hale.AddCustomAttribute("melee bounds multiplier", 1.4, -1);
    hale.AddCustomAttribute("no crit boost", 1, -1);
    hale.AddCustomAttribute("crit mod disabled hidden", 0, -1);
    hale.AddCustomAttribute("increase player capture value", 2, -1);
    hale.AddCustomAttribute("increased air control", 2.5, -1);
    hale.AddCustomAttribute("cannot pick up intelligence", 1, -1);
    hale.AddCustomAttribute("patient overheal penalty", 1, -1);
    hale.AddCustomAttribute("health from packs decreased", 0, -1);
    //hale.AddCustomAttribute("damage force reduction", 0.75, -1);
    hale.AddCustomAttribute("dmg bonus vs buildings", 10, -1);
    //hale.AddCustomAttribute("SET BONUS: dmg from sentry reduced", 0.25, -1);
    hale.AddCustomAttribute("dmg taken from crit reduced", 0.75, -1);

    hale.AddCond(Constants.ETFCond.TF_COND_CANNOT_SWITCH_FROM_MELEE);
}
AddListener("spawn", TrySpawnAsHale, 0);