//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

haleJumpStatus <- HALE_JUMP_STATUS.WALKING
haleRageDamageBucket <- 0
haleLastRageTimeStamp <- 0
haleWillStomp <- false
haleLastTimeOnGround <- 0
::haleIsCharge <- false
::haleIsSlam <- false
::haleChargeMeter <- 0
::haleSlamMeter <- 0
::halePunchMeter <- -30
halePrimTime <- 0
haleHand <- 0
bashedByHale <- []
slammedByHale <- []
::voiceRNG <- 0
::voiceTime <- 0
haleSlamVel <- 0
haleStunTimer <- 0
lastHolidayPunchTime <- 0
voiceRNG <- 0
::slamScale <- 0
::haleStartHp <- 0

function TickHale(void)
{
    local hale = GetHale();
    if (IsNotHale(hale) || roundWon)
        return;

    TickSetupHealth(hale);
    TickBossBar(hale);
    TickBraveJump(hale);
    TickPunch(hale);
    //TickRage(hale);
    TickStomp(hale);
    TickKludges(hale);
    TickCharge(hale);
    TickSlam(hale);
    TickStunBreakOut(hale);
}
AddListener("tick", TickHale, 1);

function TickStunBreakOut(hale)
{
    if (hale.InCond(Constants.ETFCond.TF_COND_STUNNED)
        || ((Time() - lastHolidayPunchTime <= 4) && hale.InCond(Constants.ETFCond.TF_COND_TAUNTING)))
        haleStunTimer+=0.1;
    else if (haleStunTimer > 0)
        haleStunTimer -=0.1;
    if (haleStunTimer < 0)
        haleStunTimer = 0;

    if (haleStunTimer >= 4)
    {
        haleStunTimer = 0;
        EmitSoundOn("VSH.Rage", hale);
        hale.RemoveCond(Constants.ETFCond.TF_COND_STUNNED);
        hale.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
        PerformSlam(hale, true);
        NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
        hale.ApplyAbsVelocityImpulse(Vector(0,0,800));
    }
}

function TickPunch(hale)
{
    if (isRoundSetup)
        return;
    if (halePunchMeter < 0)
    {
        halePunchMeter+=0.1;
        if (halePunchMeter >= 0)
        {
            EmitSoundOn("VSH.PunchReadyVO", hale);
            EmitSoundOnClient("VSH.PunchReadySFX", hale);
            NetProps.SetPropEntity(hale, "m_hActiveWeapon", hale.GiveWeapon("Hale's Own Crits"));
            halePunchMeter = 0;
        }
    }
}

function TickSlam(hale)
{
    if (isRoundSetup)
        return;
    if (haleSlamMeter < 0)
    {
        haleSlamMeter+=0.1;
        if (haleSlamMeter > 0)
            haleSlamMeter = 0;
    }
    if (haleIsCharge || haleSlamMeter < 0)
    {
        haleIsSlam = false;
        return;
    }
    if (!(hale.GetFlags() & Constants.FPlayer.FL_ONGROUND)
        && (hale.GetFlags() & Constants.FPlayer.FL_DUCKING))
    {
        haleIsSlam = true;
        hale.SetGravity(3);
        haleSlamVel = hale.GetAbsVelocity().z;
        if (haleSlamVel < -700)
            hale.AddCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART_DASH);
    }
    else if (haleIsSlam && (hale.GetFlags() & Constants.FPlayer.FL_ONGROUND))
    {
        PerformSlam(hale);
    }
}

function PerformSlam(hale, bypassVelCheck = false)
{
    hale.RemoveCond(Constants.ETFCond.TF_COND_HALLOWEEN_KART_DASH);
    hale.SetGravity(1);
    haleIsSlam = false;
    if (bypassVelCheck || haleSlamVel < -700)
    {
        local scale = clamp(-haleSlamVel, 700, 1500) / 4
        DispatchParticleEffect("hammer_impact_button", hale.GetOrigin() + Vector(0,0,20), Vector(0,0,0));
        EmitSoundOn("VSH.Slam.Impact", hale);
        haleSlamVel = 0;
        haleSlamMeter = -5;

        local currentWeapon = hale.GetActiveWeapon();
        local mannthreadsWeapon = NetProps.GetPropEntityArray(hale, "m_hMyWeapons", 1);
        NetProps.SetPropEntity(hale, "m_hActiveWeapon", mannthreadsWeapon);

        foreach(player in GetAliveMercs())
        {
            local posDiff = player.GetCenter() - hale.GetCenter();
            local distance = posDiff.Norm();
            if (distance > 400)
                continue;

            local distanceToDamage = distance < 100 ? 1 : 2.0 / sqrt(distance);
            local distanceToPush = distance < 100 ? 10 : 10 / sqrt(distance);

            NetProps.SetPropEntity(player, "m_hGroundEntity", null);
            posDiff.x = posDiff.x * 1250 * distanceToPush;
            posDiff.y = posDiff.y * 1250 * distanceToPush;
            posDiff.z = 950 * distanceToPush;
            player.ApplyAbsVelocityImpulse(posDiff);
            player.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), posDiff, player.GetCenter(), player.GetMaxHealth() * distanceToDamage, 1);
        }

        local building = null;
        while (building = Entities.FindByClassname(building, "obj_*"))
        {
            local posDiff = building.GetCenter() - hale.GetCenter();
            local distance = posDiff.Norm();
            if (distance > 400)
                continue;

            local distanceToDamage = distance < 100 ? 1 : 2.0 / sqrt(distance);

            building.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), Vector(0,0,0), building.GetCenter(), building.GetMaxHealth() * distanceToDamage, 1);
        }
        NetProps.SetPropEntity(hale, "m_hActiveWeapon", currentWeapon);

        ScreenShake(hale.GetCenter(), 10, 2.5, 1, 1000, 0, true);
    }
}

function TickCharge(hale)
{
    if (isRoundSetup || haleIsCharge)
        return;
    local buttons = NetProps.GetPropInt(hale, "m_nButtons");

    if (haleChargeMeter < 0)
    {
        haleChargeMeter+=0.1;
        if (haleChargeMeter > 0)
        {
            EmitSoundOnClient("TFPlayer.ReCharged", hale);
            haleChargeMeter = 0;
        }
        else
            return;
    }

    if (hale.GetTimeSinceCalledForMedic() < 0.5
        || hale.IsUsingActionSlot()
        || (buttons & Constants.FButtons.IN_ATTACK3)
        || (buttons & Constants.FButtons.IN_RELOAD))
    {
        haleChargeMeter += 0.06;
        if (haleChargeMeter >= 1.0)
            haleChargeMeter = 1.0;
        local main_viewmodel = NetProps.GetPropEntity(hale, "m_hViewModel")
        local sequenceId = main_viewmodel.LookupSequence("grapple_pull_idle");
        if (main_viewmodel.GetSequence() != sequenceId)
            main_viewmodel.SetSequence(sequenceId)
        hale.AddCustomAttribute("no_attack", 0.25, 0.1);
        if (Time() > voiceTime)
        {
            voiceRNG = RandomInt(1,3)
            voiceTime = Time() + 5
            EmitSoundOn("VSH.Charge"+voiceRNG, hale);
            EmitSoundOn("VSH.ChargeSFX", hale);
        }
        hale.AddCustomAttribute("move speed penalty", 0.25, 0.1);
    }
    else if (haleChargeMeter >= 0.01)
    {
        haleIsCharge = true;
        bashedByHale = [];

        DoEntFire("hale_charge_zone", "Enable", "", 0, hale, hale)
        DoEntFire("hale_charge_catapult", "Enable", "", 0, hale, hale)

        local haleChargeMeterMapped = haleChargeMeter / 1.66 + 0.4;

        NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
        local forward = hale.EyeAngles();
        local pitch = hale.GetFlags() & Constants.FPlayer.FL_ONGROUND ? forward.Pitch() - 10 : forward.Pitch();
        forward = QAngle(pitch, forward.Yaw(), 0);
        hale.ApplyAbsVelocityImpulse(forward.Forward() * 800 * haleChargeMeterMapped)
        hale.SetGravity(0.3);
        voiceTime = 0;

        hale.AddCondEx(100, haleChargeMeterMapped, null);
        hale.AddCondEx(Constants.ETFCond.TF_COND_SHIELD_CHARGE, haleChargeMeterMapped, null);
        hale.AddCondEx(Constants.ETFCond.TF_COND_KNOCKED_INTO_AIR, haleChargeMeterMapped, null);
        hale.AddCustomAttribute("no_attack", 1, haleChargeMeterMapped);
        EmitSoundOn("VSH.Dash"+voiceRNG, hale);
        EmitSoundOn("VSH.DashSFX", hale);
        DoEntFire("logic_script_vsh", "RunScriptCode", "StopCharge(activator)", haleChargeMeterMapped, hale, hale)
    }
}

function StopCharge(hale)
{
    haleChargeMeter = -10;
    haleIsCharge = false;
    //local velocity = hale.GetAbsVelocity();
    hale.SetGravity(1);
    //hale.SetAbsVelocity(Vector(velocity.x/3,velocity.y/3,velocity.z/3));
    DoEntFire("hale_charge_zone", "Disable", "", 0, hale, hale)
    DoEntFire("hale_charge_catapult", "Disable", "", 0, hale, hale)
}

function GetBashedByHale(victim)
{
    local hale = GetHale();
    if (IsNotHale(hale) || IsHale(victim) || bashedByHale.find(victim) != null)
        return;

    bashedByHale.push(victim);
    EmitSoundOn("DemoCharge.HitFlesh", victim);

    NetProps.SetPropEntity(victim, "m_hGroundEntity", null);
    local victimVelocity = victim.GetAbsVelocity();
    if (victimVelocity.z < 0)
        victimVelocity.z = 0;

    local forward = victim.GetCenter() - hale.GetCenter();
    forward.Norm();
    forward.z = 350;
    forward.x = forward.x * 1250
    forward.y = forward.y * 1250
    victim.SetAbsVelocity(victimVelocity + forward);

    victim.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), forward, victim.GetCenter(), victim.GetMaxHealth() * 0.8, 1);
}

/*function GetSlammedByHale(victim)
{
    local hale = GetHale();
    if (IsNotHale(hale) || IsHale(victim) || slammedByHale.find(victim))
        return;

    slammedByHale.push(victim);

    NetProps.SetPropEntity(victim, "m_hGroundEntity", null);
    local victimVelocity = victim.GetAbsVelocity();
    if (victimVelocity.z < 0)
        victimVelocity.z = 0;

    local forward = victim.GetCenter() - hale.GetCenter();
    forward.Norm();
    forward.z = slamScale * 2;
    forward.x = forward.x * 125
    forward.y = forward.y * 125
    victim.SetAbsVelocity(victimVelocity + forward);

    victim.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), forward, victim.GetCenter(), victim.GetMaxHealth() * 0.35, 1);
}*/

function TickSetupHealth(hale)
{
    if (!isRoundSetup)
        return;
    local maxHealth = CalcHaleMaxHealth(GetTotalPlayerCount() - 1);
    hale.SetHealth(maxHealth);
    hale.SetMaxHealth(maxHealth);
    hale.RemoveCustomAttribute("max health additive bonus");
    hale.AddCustomAttribute("max health additive bonus", maxHealth - 300, -1);
    haleStartHp = maxHealth;
}

function TickBossBar(hale)
{
    local bossBar = Entities.FindByClassname(null, "monster_resource");

    if (NetProps.GetPropInt(hale, "m_lifeState") != 0)
    {
        NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
        return;
    }
    local hpByte = (hale.GetHealth() * 255) / hale.GetMaxHealth();
    if (hpByte == 0 && hale.GetHealth() > 0)
        hpByte = 1;
    if (hpByte > 255)
        hpByte = 255;
    NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", hpByte);
}

function TickBraveJump(hale)
{
    if (isRoundSetup)
        return;
    local buttons = NetProps.GetPropInt(hale, "m_nButtons");

    if (!(hale.GetFlags() & Constants.FPlayer.FL_ONGROUND))
    {
        if (haleJumpStatus == HALE_JUMP_STATUS.WALKING)
            haleJumpStatus = HALE_JUMP_STATUS.JUMP_STARTED;
        else if (haleJumpStatus == HALE_JUMP_STATUS.JUMP_STARTED && !(buttons & Constants.FButtons.IN_JUMP))
            haleJumpStatus = HALE_JUMP_STATUS.CAN_DOUBLE_JUMP;
    }
    else
        haleJumpStatus = HALE_JUMP_STATUS.WALKING;

    if (buttons & Constants.FButtons.IN_JUMP && haleJumpStatus == HALE_JUMP_STATUS.CAN_DOUBLE_JUMP)
    {
        EmitSoundOn("VSH.Jump", hale);
        haleJumpStatus = HALE_JUMP_STATUS.DOUBLE_JUMPED;

        local eyeAngles = hale.EyeAngles();
        local forward = eyeAngles.Forward();
        forward.z = 0;
        forward.Norm();
        local left = eyeAngles.Left();
        left.z = 0;
        left.Norm();

        local forwardmove = 0
        if (buttons & Constants.FButtons.IN_FORWARD)
            forwardmove = 1;
        else if (buttons & Constants.FButtons.IN_BACK)
            forwardmove = -1;
        local sidemove = 0
        if (buttons & Constants.FButtons.IN_MOVELEFT)
            sidemove = -1;
        else if (buttons & Constants.FButtons.IN_MOVERIGHT)
            sidemove = 1;

        local newVelocity = Vector(0,0,0);
        newVelocity.x = forward.x * forwardmove + left.x * sidemove;
        newVelocity.y = forward.y * forwardmove + left.y * sidemove;
        newVelocity.Norm();
        newVelocity *= 300;
        newVelocity.z = haleJumpForce

        local currentVelocity = hale.GetAbsVelocity();
        if (currentVelocity.z < 0)
            currentVelocity.z = 0;

        NetProps.SetPropEntity(hale, "m_hGroundEntity", null);
        hale.SetAbsVelocity(currentVelocity + newVelocity)
    }
}

function TickRage(hale)
{
    local rage = haleRageDamageBucket*100 / haleMaxRageDamage;
    hale.SetRageMeter(rage > 100 ? 100 : rage);

    if (hale.GetTimeSinceCalledForMedic() < 1 || hale.IsUsingActionSlot() || (NetProps.GetPropInt(hale, "m_nButtons") & Constants.FButtons.IN_ATTACK3))
        PerformRage(hale);
}

function TickStomp(hale)
{
    if (hale.IsJumping())
        haleWillStomp = hale.GetAbsVelocity().LengthSqr() > 90000 //300^2;
    else
    {
        if (haleWillStomp)
        {
            local victim = NetProps.GetPropEntity(hale,"m_hGroundEntity");
            if (IsValidPlayer(victim))
            {
                local currentWeapon = hale.GetActiveWeapon();
                local mannthreadsWeapon = NetProps.GetPropEntityArray(hale, "m_hMyWeapons", 1);
                NetProps.SetPropEntity(hale, "m_hActiveWeapon", mannthreadsWeapon);
                victim.TakeDamageEx(hale, hale, mannthreadsWeapon, Vector(0,0,0), hale.GetOrigin(), 666, 1);
                NetProps.SetPropEntity(hale, "m_hActiveWeapon", currentWeapon);
                EmitAmbientSoundOn("Weapon_Mantreads.Impact", 8, 1, 100, victim);
                EmitAmbientSoundOn("Player.FallDamageDealt", 4, 1, 100, victim);
                DispatchParticleEffect("stomp_text", hale.GetOrigin(), Vector(0,0,0));
            }
        }
        haleWillStomp = false;
    }
}

function TickKludges(hale)
{
    hale.RemoveCond(Constants.ETFCond.TF_COND_CRITBOOSTED_PUMPKIN);
}

function AddDamageToRageMeter(damage)
{
    haleRageDamageBucket += damage;
    if (haleRageDamageBucket > haleMaxRageDamage)
        haleRageDamageBucket = haleMaxRageDamage;
}

function PerformRage(hale)
{
    if (haleRageDamageBucket < haleMaxRageDamage)
        return;
    EmitSoundOn("VSH.Rage", hale);
    haleRageDamageBucket = 0;
    haleLastRageTimeStamp = Time()

    local stunTrigger = Entities.FindByName(null, "hale_stun_trigger");
    if (stunTrigger != null)
    {
        stunTrigger.SetOrigin(hale.EyePosition());
        EntFireByHandle(stunTrigger, "Enable", "", 0.1, hale, hale);
        EntFireByHandle(stunTrigger, "DisableAndEndTouch", "", 0.5, hale, hale);
    }

    local target = null;
    while (target = Entities.FindByClassnameWithin(target, "obj_*", hale.EyePosition(), haleRageRadius))
    {
        NetProps.SetPropInt(target, "m_bDisabled", 1);

        local particlePos = target.EyePosition();
        particlePos.z += 20;
        DispatchParticleEffect("yikes_text", particlePos, Vector(0,0,0));
        DoEntFire("logic_script_vsh", "RunScriptCode", "ReEnableSentry(activator)", haleRageStunDuration, target, target)
    }

    hale.RemoveCond(Constants.ETFCond.TF_COND_STUNNED);
    hale.RemoveCond(Constants.ETFCond.TF_COND_TAUNTING);
}

function ReEnableSentry(sentry)
{
    NetProps.SetPropInt(sentry, "m_bDisabled", 0);
}