//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function MercTookDamageEvent(params)
{
    local hale = params.attacker;
    local victim = params.const_entity;

    if (IsHale(hale) && IsMercAlive(victim))
        HaleSplashDamage(params);
}
AddListener("damage", MercTookDamageEvent, 0);

function HaleSplashDamage(params)
{
    local hale = params.attacker;
    local victim = params.const_entity;

    if (IsNotHale(hale) || IsNotValidPlayer(victim) || params.damage_type == 1)
        return;

    local player = null;
    while (player = Entities.FindByClassnameWithin(player, "player*", victim.GetOrigin(), haleSplashRadius))
    {
        if (player != victim && player != hale)
            player.TakeDamageEx(hale, hale, hale.GetActiveWeapon(), hale.GetCenter() - player.GetCenter(), player.GetCenter(), params.damage / 2, 1);
    }
}

function InstaRespawnDuringSetup(params)
{
    if (IsInWaitingForPlayers() || isRoundSetup || isFeedbackRound)
    {
        local player;
        if ((player = GetPlayerFromParams(params)) == null)
            return;
        player.ForceRegenerateAndRespawn();
    }
}
AddListener("death", InstaRespawnDuringSetup, 0);


function MercSpawnedMidRoundEvent(player)
{
    if (IsInWaitingForPlayers() || isRoundSetup || isFeedbackRound)
        return;
    player.TakeDamage(9999,0,null);
}
AddListener("spawn", MercSpawnedMidRoundEvent, -1);
