//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function TickMercs(void)
{
    if (!isRoundSetup)
        foreach (player in GetAliveMercs())
            TickMerc(player);

    local bookWeapon = null;
    while (bookWeapon = Entities.FindByClassname(bookWeapon, "tf_weapon_spellbook"))
    {
        local spellId = NetProps.GetPropInt(bookWeapon, "m_iSelectedSpellIndex");
        if (spellId == TF_SPELLS.SKELETON_HORDE || spellId  == TF_SPELLS.MINIFY)
        {
            NetProps.SetPropInt(bookWeapon, "m_iSelectedSpellIndex", TF_SPELLS.SHADOW_LEAP);
            NetProps.SetPropInt(bookWeapon, "m_iSpellCharges", 2);
        }
    }
}
AddListener("tick", TickMercs, 0);

function TickMerc(player)
{
    local playerClass = player.GetPlayerClass();
    local weapon = player.GetActiveWeapon();

    local mercsAlive = GetAliveMercCount();
    if (mercsAlive <= 3)
        player.AddCond(Constants.ETFCond.TF_COND_OFFENSEBUFF);
    if (mercsAlive == 1)    //No, it's not "else if", because engie+sentry benefit from both crits and minicrits
        player.AddCond(Constants.ETFCond.TF_COND_CRITBOOSTED_ON_KILL);

    if (weapon != null
            && playerClass != TF_CLASS.SPY
            && GTFW_ReturnWeaponBySlotBool(weapon, TF_WEAPONSLOTS.MELEE)
            && weapon.GetWeaponId() != 656) //Holiday Punch gets no free crits
        player.AddCondEx(Constants.ETFCond.TF_COND_CRITBOOSTED_ON_KILL, 0.2, null);
}