//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

injectRoundLogic <- true

haleJumpForce <- 825
haleMaxRageDamage <- 3000
haleRageRadius <- 600
haleSplashRadius <- 75
haleRageStunDuration <- 5

function SetHaleJumpForce(newJumpForce)
{
    haleJumpForce = newJumpForce;
}

function CalcHaleMaxHealth(mercCount)
{
    if (mercCount < 1)
        mercCount = 1;

    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    local globalVars = gamerules.GetScriptScope();

    if (!("multiplierPerPlayer" in globalVars))
        globalVars.multiplierPerPlayer <- 45;

    return mercCount * mercCount * globalVars.multiplierPerPlayer + 500;
}

function CalcDeathPitDamage()
{
    local hale = GetHale();
    return hale == null ? 1000 : clamp(hale.GetMaxHealth() / 10, 1000, 5000);
}

function CalcStabDamage()
{
    local hale = GetHale();
    return hale == null ? 500 : clamp(hale.GetMaxHealth() / 15, 500, 5000);
}
