//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function PlaySoundForAll(soundScript)
{
    local player = null;
    while (player = Entities.FindByClassname(player, "player"))
        EmitSoundOnClient(soundScript, player);
}

::clamp <- function (value, min, max)
{
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}

::CTFWeaponBase.GetWeaponId <- function()
{
    return NetProps.GetPropInt(this, "m_AttributeManager.m_Item.m_iItemDefinitionIndex");
}

function IsValidPlayer(player)
{
    try
    {
        return player != null && player.IsValid() && player.IsPlayer() && player.GetTeam() > 1;
    }
    catch(e)
    {
        return false;
    }
}

function IsValidPlayerOrBuilding(entity)
{
    try
    {
        return entity != null
            && entity.IsValid()
            && (entity.IsPlayer() || entity.GetClassname().find("obj_") == 0)
            && entity.GetTeam() > 1;
    }
    catch(e)
    {
        return false;
    }
}

function IsValidBuilding(building)
{
    try
    {
        return building != null
            && building.IsValid()
            && building.GetClassname().find("obj_") == 0
            && building.GetTeam() > 1;
    }
    catch(e)
    {
        return false;
    }
}

function IsNotValidPlayer(player)
{
    try
    {
        return player == null || !player.IsValid() || !player.IsPlayer() || player.GetTeam() <= 1;
    }
    catch (e)
    {
        return true;
    }
}


function GetAliveMercCount()
{
    local aliveCount = 0;
    local player = null;
    while (player = Entities.FindByClassname(player, "player"))
        if (IsMercAlive(player))
            aliveCount++;
    return aliveCount;
}

function GetAliveMercs()
{
    local player = null;
    while (player = Entities.FindByClassname(player, "player"))
        if (IsMercAlive(player))
            yield player;
    return null;
}

function GetTotalPlayerCount()
{
    local aliveCount = 0;
    local player = null;
    while (player = Entities.FindByClassname(player, "player"))
        if (IsValidPlayer(player))
            aliveCount++;
    return aliveCount;
}

function GetPlayerFromParams(params, key = "userid")
{
	if (!(key in params))
        return null;
    local player = GetPlayerFromUserID(params[key]);
    if (IsValidPlayer(player))
        return player;
    return null;
}